%define        majversion  %(echo %version | cut -d. -f 1-2)
## *AUTOSPEC-OFF*
%define        vimdir      %{name}%(majversion=%majversion; echo ${majversion/\./})
## *AUTOSPEC-ON*
%define        langversion 7.2
%define        with_gvim   0

Name:          vim
Version:       8.2.2601
Release:       1mamba
Summary:       VIsual editor iMproved
Group:         Applications/Text
Vendor:        openmamba
Distribution:  openmamba
Packager:      Silvan Calarco <silvan.calarco@mambasoft.it>
URL:           https://www.vim.org/
Source:        https://github.com/vim/vim.git/v%{version}/vim-%{version}.tar.bz2
#Source0:       ftp://ftp.vim.org/pub/vim/unix/vim-%{majversion}.tar.bz2
#Source1:       ftp://ftp.vim.org/pub/vim/extra/vim-%{langversion}-lang.tar.gz
Source2:       vimrc-skel
# patches got from: ftp://ftp.vim.org/pub/vim/patches/%{majversion}
# create full patches archive with vim-patches.sh script below
#Source3:       %{name}-%{version}-patchset.tar.gz
#Source4:       vim-autoupdate
License:       Charityware
## AUTOBUILDREQ-BEGIN
BuildRequires: glibc-devel
BuildRequires: libgpm-devel
BuildRequires: libncurses-devel
BuildRequires: libperl
BuildRequires: libselinux-devel
BuildRequires: libtcl-devel
BuildRequires: ruby-devel
## AUTOBUILDREQ-END
BuildRequires: perl-devel >= 2:5.8.7
BuildRequires: libpython-devel >= 2.3.4
BuildRequires: libtcl >= 8.4.11
BuildRequires: gettext-devel

%description
VIM (VIsual editor iMproved) is an updated and improved version of the vi editor.
Vi was the first real screen-based editor for UNIX, and is still very popular.
VIM improves on vi by adding new features: multiple windows, multi-level undo, block highlighting and more. VIM-X11 is a version of the VIM editor which will run within the X Window System.
If you install this package, you can run VIM as an X application with a full GUI interface and mouse support.

%package doc
Group:         Documentation
Summary:       Documentation for %{name}
Requires:      %{name} = %{?epoch:%epoch:}%{version}-%{release}

%description doc
VIM (VIsual editor iMproved) is an updated and improved version of the vi editor.
Vi was the first real screen-based editor for UNIX, and is still very popular.
VIM improves on vi by adding new features: multiple windows, multi-level undo, block highlighting and more. VIM-X11 is a version of the VIM editor which will run within the X Window System.
If you install this package, you can run VIM as an X application with a full GUI interface and mouse support.
This package provides documentation files.

%package tutor
Group:         Applications/Text
Summary:       Tutorial files for %{name}
Requires:      %{name} = %{?epoch:%epoch:}%{version}-%{release}

%description tutor
VIM (VIsual editor iMproved) is an updated and improved version of the vi editor.
Vi was the first real screen-based editor for UNIX, and is still very popular.
VIM improves on vi by adding new features: multiple windows, multi-level undo, block highlighting and more. VIM-X11 is a version of the VIM editor which will run within the X Window System.
If you install this package, you can run VIM as an X application with a full GUI interface and mouse support.
This package provides tutorial files.

%prep
%setup -q

## apply big patches
#mkdir patches
#cd patches
#tar xf %{SOURCE3}
#cd ..
#ls patches/| sort -V | while read f; do
#   [ "$f" = "8.0.0001" -o "$f" = "8.0.0002" -o "$f" = "8.0.0014" ] && {
#      cat patches/$f | patch -p0 -f || true
#      continue
#   }
#   cat patches/$f | patch -p0
#done

%define _use_internal_dependency_generator 0

# Find requires modified
%define __find_requires %{_builddir}/%{name}-%{version}/find_requires.sh

# Find requires will ignore datadir files to avoid a wrong /bin/csh requirement
cat > find_requires.sh << _EOF
#! /bin/sh
grep -v %{_datadir} | %{_prefix}/lib/rpm/find-requires %{buildroot} %{_target_cpu} 
_EOF

chmod +x find_requires.sh

sed -i '
   s,SYS_VIMRC_FILE "\$VIM/vimrc",SYS_VIMRC_FILE "%{_sysconfdir}/vim/vimrc",
   s,SYS_GVIMRC_FILE "\$VIM/gvimrc",SYS_GVIMRC_FILE "%{_sysconfdir}/vim/gvimrc",' \
src/os_unix.h

# disable command echo
#for i in runtime/{gvimrc_example.vim,vimrc_example.vim}; do
#   sed -i 's/^set showcmd/set noshowcmd/' $i
#done

%define localedir %{buildroot}%{_datadir}/locale/

%build
# build gvim
%if %{with_gvim}

#LOCALEDIR=%{localedir} \
%configure \
   --with-compiledby="%{packager}" \
   --with-features=huge \
   --with-x=yes \
   --enable-gui=gnome2 \
   --enable-gtk2-check \
   --enable-xim \
   --enable-fontset \
   --enable-nls \
   --enable-perlinterp \
   --enable-pythoninterp \
   --enable-tclinterp \
   --enable-rubyinterp \
   --enable-cscope \
   --disable-acl \
   --enable-multibyte 

# disable the '-g' option
%make &&
mv src/vim src/gvim
%make -C src clean CC=%{_target_platform}-gcc

%endif

# build vim
#LOCALEDIR=%{localedir} \
%configure \
   --with-compiledby="%{packager}" \
   --with-features=huge \
   --with-x=no \
   --enable-gui=no \
   --enable-nls \
   --enable-perlinterp \
   --enable-pythoninterp \
   --enable-tclinterp \
   --enable-rubyinterp \
   --enable-cscope \
   --disable-acl \
   --enable-multibyte

#sed -i '
#   s,LOCALEDIR=$(DEST_LANG),LOCALEDIR=$(DESTDIR)$(prefix)/share/locale,g' \
#src/Makefile

%make
#% make lang

%install
[ "%{buildroot}" != / ] && rm -rf "%{buildroot}"
%makeinstall

ln -s vim %{buildroot}%{_bindir}/vi
install -m 0644 -D %{S:2} %{buildroot}%{_sysconfdir}/skel/.vimrc
install -m 0644 -D %{S:2} %{buildroot}/root/.vimrc

%if %{with_gvim}
install -m 0755 -D src/gvim %{buildroot}%{_bindir}/gvim
%endif

%find_lang %{name} --with-man --all-name

%clean
[ "%{buildroot}" != / ] && rm -rf "%{buildroot}"

%files -f %{name}.lang
%defattr(-,root,root)
%{_sysconfdir}/skel/.vimrc
%{_bindir}/*
%{_datadir}/applications/gvim.desktop
%{_datadir}/applications/vim.desktop
%dir %{_datadir}/vim/%{vimdir}
%{_datadir}/vim/%{vimdir}/*
%exclude %{_datadir}/vim/%{vimdir}/doc
%exclude %{_datadir}/vim/%{vimdir}/tutor
%{_datadir}/icons/locolor/*/apps/gvim.png
%{_datadir}/icons/hicolor/*/apps/gvim.png
%{_mandir}/man1/*
%if %{with_gvim}
%{_bindir}/gvim
%endif
/root/.vimrc

%files doc
%defattr(-,root,root)
%{_datadir}/vim/%{vimdir}/doc

%files tutor
%defattr(-,root,root)
%{_datadir}/vim/%{vimdir}/tutor

%changelog
* Mon Mar 15 2021 Automatic Build System <autodist@mambasoft.it> 8.2.2601-1mamba
- automatic version update by autodist

* Sat Mar 13 2021 Automatic Build System <autodist@mambasoft.it> 8.2.2591-1mamba
- automatic version update by autodist

* Fri Mar 12 2021 Automatic Build System <autodist@mambasoft.it> 8.2.2590-1mamba
- automatic version update by autodist

* Thu Mar 11 2021 Automatic Build System <autodist@mambasoft.it> 8.2.2589-1mamba
- automatic version update by autodist

* Thu Mar 11 2021 Automatic Build System <autodist@mambasoft.it> 8.2.2584-1mamba
- automatic version update by autodist

* Tue Mar 09 2021 Automatic Build System <autodist@mambasoft.it> 8.2.2580-1mamba
- automatic version update by autodist

* Tue Mar 09 2021 Automatic Build System <autodist@mambasoft.it> 8.2.2577-1mamba
- automatic version update by autodist

* Mon Mar 08 2021 Automatic Build System <autodist@mambasoft.it> 8.2.2576-1mamba
- automatic version update by autodist

* Sun Mar 07 2021 Automatic Build System <autodist@mambasoft.it> 8.2.2572-1mamba
- automatic version update by autodist

* Thu Mar 04 2021 Automatic Build System <autodist@mambasoft.it> 8.2.2566-1mamba
- automatic version update by autodist

* Thu Mar 04 2021 Automatic Build System <autodist@mambasoft.it> 8.2.2562-1mamba
- automatic version update by autodist

* Wed Mar 03 2021 Automatic Build System <autodist@mambasoft.it> 8.2.2561-1mamba
- automatic version update by autodist

* Mon Mar 01 2021 Automatic Build System <autodist@mambasoft.it> 8.2.2559-1mamba
- automatic version update by autodist

* Sun Feb 28 2021 Automatic Build System <autodist@mambasoft.it> 8.2.2557-1mamba
- automatic version update by autodist

* Sun Feb 28 2021 Automatic Build System <autodist@mambasoft.it> 8.2.2553-1mamba
- automatic version update by autodist

* Fri Feb 26 2021 Automatic Build System <autodist@mambasoft.it> 8.2.2550-1mamba
- automatic version update by autodist

* Thu Feb 25 2021 Automatic Build System <autodist@mambasoft.it> 8.2.2549-1mamba
- automatic version update by autodist

* Wed Feb 24 2021 Automatic Build System <autodist@mambasoft.it> 8.2.2544-1mamba
- automatic version update by autodist

* Tue Feb 23 2021 Automatic Build System <autodist@mambasoft.it> 8.2.2543-1mamba
- automatic version update by autodist

* Thu Jan 21 2021 Automatic Build System <autodist@mambasoft.it> 8.2.2380-1mamba
- automatic version update by autodist

* Fri Jan 15 2021 Automatic Build System <autodist@mambasoft.it> 8.2.2347-1mamba
- automatic version update by autodist

* Sun Nov 15 2020 Automatic Build System <autodist@mambasoft.it> 8.2.1989-1mamba
- automatic version update by autodist

* Fri Sep 18 2020 Automatic Build System <autodist@mambasoft.it> 8.2.1704-1mamba
- automatic version update by autodist

* Tue Sep 15 2020 Automatic Build System <autodist@mambasoft.it> 8.2.1684-1mamba
- automatic version update by autodist

* Tue Sep 08 2020 Automatic Build System <autodist@mambasoft.it> 8.2.1634-1mamba
- automatic version update by autodist

* Fri Sep 04 2020 Automatic Build System <autodist@mambasoft.it> 8.2.1584-1mamba
- automatic version update by autodist

* Sun Aug 30 2020 Automatic Build System <autodist@mambasoft.it> 8.2.1537-1mamba
- automatic version update by autodist

* Sat Aug 29 2020 Automatic Build System <autodist@mambasoft.it> 8.2.1523-1mamba
- automatic version update by autodist

* Tue Aug 25 2020 Automatic Build System <autodist@mambasoft.it> 8.2.1522-1mamba
- automatic version update by autodist

* Sun May 24 2020 Automatic Build System <autodist@mambasoft.it> 8.2.0814-1mamba
- automatic version update by autodist

* Sat May 09 2020 Automatic Build System <autodist@mambasoft.it> 8.2.0717-1mamba
- automatic version update by autodist

* Sun Apr 05 2020 Automatic Build System <autodist@mambasoft.it> 8.2.0510-1mamba
- automatic version update by autodist

* Mon Mar 02 2020 Automatic Build System <autodist@mambasoft.it> 8.2.0343-1mamba
- automatic version update by autodist

* Mon Jan 27 2020 Automatic Build System <autodist@mambasoft.it> 8.2.0148-1mamba
- automatic version update by autodist

* Wed Jan 08 2020 Automatic Build System <autodist@mambasoft.it> 8.2.0100-1mamba
- automatic version update by autodist

* Fri Jan 03 2020 Automatic Build System <autodist@mambasoft.it> 8.2.0033-1mamba
- automatic version update by autodist

* Fri Nov 08 2019 Automatic Build System <autodist@mambasoft.it> 8.1.2268-1mamba
- automatic version update by autodist

* Mon Sep 30 2019 Automatic Build System <autodist@mambasoft.it> 8.1.2102-1mamba
- automatic version update by autodist

* Wed Sep 11 2019 Automatic Build System <autodist@mambasoft.it> 8.1.1968-1mamba
- automatic version update by autodist

* Thu Aug 22 2019 Automatic Build System <autodist@mambasoft.it> 8.1.1906-1mamba
- automatic version update by autodist

* Tue Jul 30 2019 Automatic Build System <autodist@mambasoft.it> 8.1.1776-1mamba
- automatic version update by autodist

* Fri Jul 05 2019 Automatic Build System <autodist@mambasoft.it> 8.1.1635-1mamba
- automatic version update by autodist

* Wed Jul 03 2019 Automatic Build System <autodist@mambasoft.it> 8.1.1616-1mamba
- automatic version update by autodist

* Wed Jul 03 2019 Automatic Build System <autodist@mambasoft.it> 8.1.1614-1mamba
- automatic version update by autodist

* Thu Jun 06 2019 Automatic Build System <autodist@mambasoft.it> 8.1.1467-1mamba
- automatic version update by autodist

* Sat Apr 27 2019 Automatic Build System <autodist@mambasoft.it> 8.1.1186-1mamba
- automatic version update by autodist

* Sun Mar 31 2019 Automatic Build System <autodist@mambasoft.it> 8.1.1073-1mamba
- automatic version update by autodist

* Thu Mar 07 2019 Automatic Build System <autodist@mambasoft.it> 8.1.0996-1mamba
- automatic version update by autodist

* Sun Feb 10 2019 Automatic Build System <autodist@mambasoft.it> 8.1.0877-1mamba
- automatic version update by autodist

* Thu Jan 17 2019 Automatic Build System <autodist@mambasoft.it> 8.1.0751-1mamba
- automatic version update by autodist

* Sat Dec 08 2018 Automatic Build System <autodist@mambasoft.it> 8.1.0570-1mamba
- automatic version update by autodist

* Fri Nov 23 2018 Automatic Build System <autodist@mambasoft.it> 8.1.0542-1mamba
- automatic version update by autodist

* Sat Nov 17 2018 Automatic Build System <autodist@mambasoft.it> 8.1.0527-1mamba
- automatic version update by autodist

* Mon Oct 15 2018 Automatic Build System <autodist@mambasoft.it> 8.1.0470-1mamba
- automatic version update by autodist

* Thu Sep 13 2018 Automatic Build System <autodist@mambasoft.it> 8.1.0374-1mamba
- automatic version update by autodist

* Sun Sep 09 2018 Silvan Calarco <silvan.calarco@mambasoft.it> 8.1.0354-1mamba
- update to 8.1.0354

* Sat Jan 28 2017 Automatic Build System <autodist@mambasoft.it> 8.0.0237-1mamba
- automatic version update by autodist

* Thu Nov 17 2016 Automatic Build System <autodist@mambasoft.it> 8.0.0086-1mamba
- automatic version update by autodist

* Mon Oct 31 2016 Automatic Build System <autodist@mambasoft.it> 8.0.0055-1mamba
- automatic version update by autodist

* Mon Oct 24 2016 Automatic Build System <autodist@mambasoft.it> 8.0.0046-1mamba
- automatic version update by autodist

* Tue Oct 04 2016 Automatic Build System <autodist@mambasoft.it> 8.0.0013-1mamba
- automatic version update by autodist

* Sat Sep 24 2016 Automatic Build System <autodist@mambasoft.it> 8.0.0005-1mamba
- automatic version update by autodist

* Sat Sep 17 2016 Automatic Build System <autodist@mambasoft.it> 8.0-1mamba
- automatic version update by autodist

* Mon Aug 08 2016 Automatic Build System <autodist@mambasoft.it> 7.4.2143-1mamba
- automatic version update by autodist

* Fri Jun 10 2016 Automatic Build System <autodist@mambasoft.it> 7.4.1910-1mamba
- automatic version update by autodist

* Sat Jun 04 2016 Automatic Build System <autodist@mambasoft.it> 7.4.1797-1mamba
- automatic version update by autodist

* Thu Feb 25 2016 Automatic Build System <autodist@mambasoft.it> 7.4.1386-1mamba
- automatic version update by autodist

* Thu Feb 11 2016 Automatic Build System <autodist@mambasoft.it> 7.4.1294-1mamba
- automatic version update by autodist

* Fri Jan 29 2016 Automatic Build System <autodist@mambasoft.it> 7.4.1190-1mamba
- automatic version update by autodist

* Fri Jan 15 2016 Automatic Build System <autodist@mambasoft.it> 7.4.1089-1mamba
- automatic version update by autodist

* Mon Jan 11 2016 Automatic Build System <autodist@mambasoft.it> 7.4.1063-1mamba
- automatic version update by autodist

* Thu Dec 03 2015 Automatic Build System <autodist@mambasoft.it> 7.4.944-1mamba
- automatic version update by autodist

* Fri Oct 02 2015 Automatic Build System <autodist@mambasoft.it> 7.4.884-1mamba
- automatic version update by autodist

* Thu Sep 17 2015 Automatic Build System <autodist@mambasoft.it> 7.4.854-1mamba
- automatic version update by autodist

* Sun Jul 12 2015 Automatic Build System <autodist@mambasoft.it> 7.4.778-1mamba
- automatic version update by autodist

* Fri Jul 03 2015 Automatic Build System <autodist@mambasoft.it> 7.4.764-1mamba
- automatic version update by autodist

* Sun Jun 28 2015 Automatic Build System <autodist@mambasoft.it> 7.4.738-1mamba
- automatic version update by autodist

* Mon May 18 2015 Automatic Build System <autodist@mambasoft.it> 7.4.729-1mamba
- automatic version update by autodist

* Sat May 16 2015 Automatic Build System <autodist@mambasoft.it> 7.4.723-1mamba
- automatic version update by autodist

* Tue Apr 28 2015 Automatic Build System <autodist@mambasoft.it> 7.4.712-1mamba
- automatic version update by autodist

* Thu Mar 19 2015 Automatic Build System <autodist@mambasoft.it> 7.4.663-1mamba
- automatic version update by autodist

* Fri Feb 06 2015 Automatic Build System <autodist@mambasoft.it> 7.4.617-1mamba
- automatic version update by autodist

* Sun Jan 18 2015 Silvan Calarco <silvan.calarco@mambasoft.it> 7.4.580-1mamba
- update to 7.4.580

* Mon Dec 01 2014 Automatic Build System <autodist@mambasoft.it> 7.4.537-1mamba
- automatic version update by autodist

* Tue Nov 25 2014 Automatic Build System <autodist@mambasoft.it> 7.4.525-1mamba
- automatic version update by autodist

* Mon Oct 13 2014 Automatic Build System <autodist@mambasoft.it> 7.4.473-1mamba
- automatic version update by autodist

* Thu Sep 25 2014 Automatic Build System <autodist@mambasoft.it> 7.4.459-1mamba
- automatic version update by autodist

* Thu Aug 28 2014 Automatic Build System <autodist@mambasoft.it> 7.4.410-1mamba
- automatic version update by autodist

* Wed Jul 30 2014 Automatic Build System <autodist@mambasoft.it> 7.4.383-1mamba
- automatic version update by autodist

* Tue Jul 29 2014 Automatic Build System <autodist@mambasoft.it> 7.4.373-1mamba
- automatic version update by autodist

* Wed Apr 09 2014 Silvan Calarco <silvan.calarco@mambasoft.it> 7.4.258-1mamba
- update to 7.4.253

* Sun Jan 12 2014 Silvan Calarco <silvan.calarco@mambasoft.it> 7.4.142-1mamba
- update to 7.4.142

* Sun Nov 17 2013 Silvan Calarco <silvan.calarco@mambasoft.it> 7.4.094-1mamba
- update to 7.4.094

* Fri Sep 13 2013 Automatic Build System <autodist@mambasoft.it> 7.4.027-1mamba
- update to 7.4.027

* Tue Aug 27 2013 Automatic Build System <autodist@mambasoft.it> 7.4.009-1mamba
- update to 7.4.009

* Sat Aug 10 2013 Automatic Build System <autodist@mambasoft.it> 7.3.1287-1mamba
- automatic version update by autodist

* Wed Dec 01 2010 Silvan Calarco <silvan.calarco@mambasoft.it> 7.3-2mamba
- fix dependencies by unsetting use_internal_dependency_generator
- update packager
- added -doc and -tutor packages

* Tue Nov 16 2010 Silvan Calarco <silvan.calarco@mambasoft.it> 7.3-1mamba
- update to 7.3
- also install .vimrc in /root

* Thu May 06 2009 Ercole 'ercolinux' Carpanetto <ercole69@gmail.com> 7.2-2mamba
- modified the .vimrc to add mode and command in the ruler, and make cursors keys works in edit mode
- modified vendor and distribution

* Fri Aug 29 2008 Silvan Calarco <silvan.calarco@mambasoft.it> 7.2-1mamba
- update to 7.2

* Mon May 14 2007 Aleph0 <aleph0@openmamba.org> 7.1-1mamba
- update to 7.1
- modified xorg paths used when building gvim

* Fri Jul 07 2006 Stefano Cotta Ramusino <stefano.cotta@qilinux.it> 7.0.037-1qilnx
- update to version 7.0.037 by autospec

* Mon Jun 26 2006 Davide Madrisan <davide.madrisan@qilinux.it> 6.4.010-2qilnx
- updated vimrc file

* Wed Apr 12 2006 Davide Madrisan <davide.madrisan@qilinux.it> 6.4.010-1qilnx
- update to version 6.4.010 by autospec

* Mon Oct 03 2005 Stefano Cotta Ramusino <stefano.cotta@qilinux.it> 6.3.090-1qilnx
- updated to patch level 090

* Mon Aug 08 2005 Davide Madrisan <davide.madrisan@qilinux.it> 6.3.086-1qilnx
- updated to patch level 086

* Thu Dec 16 2004 Davide Madrisan <davide.madrisan@qilinux.it> 6.3-3qilnx
- security fix QSA-2004-064 (CAN-2004-1138)
- added new patches from ftp://ftp.vim.org/pub/vim/patches/6.3/

* Wed Nov 17 2004 Davide Madrisan <davide.madrisan@qilinux.it> 6.3-2qilnx
- rebuild with patches from ftp://ftp.vim.org/pub/vim/patches/6.3/
- fixed security issues in `vimspell.sh' and `tcltags' (insecure creation
  of temporary files)

* Tue Jun 08 2004 Davide Madrisan <davide.madrisan@qilinux.it> 6.3-1qilnx
- new version rebuild
- added localisation

* Tue Feb 17 2004 Davide Madrisan <davide.madrisan@qilinux.it> 6.2-1qilnx
- new version rebuild

* Mon Apr 23 2003 Silvan Calarco <silvan.calarco@qinet.it> 6.1-4qilnx
- added .vimrc default skeleton file

* Mon Apr 17 2003 Silvan Calarco <silvan.calarco@qinet.it> 6.1-3qilnx
- removed Prefix definition
- modified find_requires script to avoid a mistaken /bin/csh requirement

* Mon Apr 14 2003 Mirko Cortillaro <mirko.cortillaro@qinet.it>
- modified file list and created infodir

* Wed Apr 02 2003 Mirko Cortillaro <mirko.cortillaro@qinet.it>
- write a spec file for vim
